//
//  AppDelegate.m
//  SixteenBitPerComponentThumbnailLeak
//
//  Created by August Mueller on 12/5/19.
//  Copyright © 2019 Flying Meat Inc. All rights reserved.
//

#import "AppDelegate.h"
#import <mach/mach.h>

@interface AppDelegate ()

@property (weak) IBOutlet NSWindow *window;
@end

@implementation AppDelegate

void report_memory(void) {
  struct task_basic_info info;
  mach_msg_type_number_t size = sizeof(info);
  kern_return_t kerr = task_info(mach_task_self(),
                                 TASK_BASIC_INFO,
                                 (task_info_t)&info,
                                 &size);
  if( kerr == KERN_SUCCESS ) {
      NSLog(@"Used memory (in mb): %f", (double)info.resident_size / 1024.0 / 1024.0);
  } else {
    NSLog(@"Error with task_info(): %s", mach_error_string(kerr));
  }
}


- (void)loadThumbnailsForImageWithName:(NSString *)name {
    
    @autoreleasepool {
        
        NSLog(@"Loading image %@", name);
        NSURL *sixteenURL = [[NSBundle mainBundle] URLForImageResource:name];
        assert(sixteenURL);
         
        CGImageSourceRef imageSourceRef = CGImageSourceCreateWithURL((CFURLRef)sixteenURL, nil);
        
        for (int i = 0; i < 500; i++) {
         
            CGImageRef r = CGImageSourceCreateThumbnailAtIndex(imageSourceRef, 0, (CFDictionaryRef)@{(id)kCGImageSourceCreateThumbnailFromImageIfAbsent: @(YES), (id)kCGImageSourceThumbnailMaxPixelSize:@(256), (id)kCGImageSourceCreateThumbnailWithTransform: @(YES)});

            assert(r);
             
            CGImageRelease(r);
        }
         
        CFRelease(imageSourceRef);
        
        NSLog(@"Finished with image %@", name);
    }
}

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification {
    
    report_memory();

    [self loadThumbnailsForImageWithName:@"EightBit"];

    report_memory();

    [self loadThumbnailsForImageWithName:@"SixteenBit"];

    report_memory();
}


@end
